#include "lolevel.h"
#include "platform.h"
#include "core.h"

const char * const new_sa = &_end;

// Forward declarations
extern volatile int jogdial_stopped;
void JogDial_task_my(void);

extern void task_CaptSeq();
extern void task_InitFileModules();
extern void task_RotaryEncoder();
extern void task_MovieRecord();
extern void task_ExpDrv();

/*----------------------------------------------------------------------
    spytask
-----------------------------------------------------------------------*/
void spytask(long ua, long ub, long uc, long ud, long ue, long uf)
{
    core_spytask();
}

/*----------------------------------------------------------------------
    CreateTask_spytask
-----------------------------------------------------------------------*/
void CreateTask_spytask()
{
    _CreateTask("SpyTask", 0x19, 0x2000, spytask, 0);
}


int blinkout(int x)
{
    *(volatile int*)0xd20b0994 = 0x4c0003;
    return x;
}




int blinkin(int x)
{
    *(volatile int*)0xd20b0994 = 0x4d0002;
    return x;
}


void __attribute__((naked,noinline)) blinkinNew() {
    asm volatile (
"    push    {r0, r1} \n"
"    ldr     r0, =0xd20b0994 \n"
"    ldr     r1, =0x4d0002 \n"
"    str     r1, [r0] \n"
"    pop     {r0, r1} \n"
"    bx      lr \n"
    );
}

void __attribute__((naked,noinline)) blinkoutNew() {
    asm volatile (
"    push    {r0, r1} \n"
"    ldr     r0, =0xd20b0994 \n"
"    ldr     r1, =0x4c0003 \n"
"    str     r1, [r0] \n"
"    pop     {r0, r1} \n"
"    bx      lr \n"
    );
}


void blinkit()
{
	int a;

	for(a=0;a<4;a++){
    int i;
           *(volatile int*)0xd20b0994 = 0x4d0002;
           for(i=0;i<1000000;i++) {
               asm volatile(
               "nop\n"
               );
           }
           *(volatile int*)0xd20b0994 = 0x4c0003;
           for(i=0;i<1000000;i++) {
               asm volatile(
               "nop\n"
               );
	   }
   }
}



/*----------------------------------------------------------------------
    boot()

    Main entry point for the CHDK code
-----------------------------------------------------------------------*/

// push all regs except SP and PC
// push CSPR via R0
// restore value for R0 from stack
#define ASM_SAFE_ENTER \
    "STMFD SP!, {R0-R12,LR}\n" \
    "MRS R0, CPSR\n" \
    "STR R0,[SP,#-4]!\n" \
    "LDR R0,[SP,#4]\n"

// pop CSPR via R0
// pop all regs except SP and PC
#define ASM_SAFE_LEAVE \
    "LDR R0,[SP],#4\n" \
    "MSR CPSR_cxsf,R0\n" \
    "LDMFD SP!, {R0-R12,LR}\n"

#define ASM_SAFE(asmcode) \
    ASM_SAFE_ENTER \
    asmcode \
    ASM_SAFE_LEAVE

void SAFEblinkout()
{
   ASM_SAFE("BL     blinkout\n");
}


/*************************************************************/
void __attribute__((naked,noinline)) boot() {

	//sx720
    asm volatile ( // 0xfc02000c

"    movw    r0, #0x4000\n"
"    movt    r0, #0\n"
"    mov     sp, r0\n"
"    bl      sub_fc02007e\n"
"    ldr     r2, =0xc0242010\n"
"    ldr     r1, [r2]\n"
"    orr     r1, r1, #1\n"
"    str     r1, [r2]\n"
"    ldr     r0, =0xfcd3b79c\n"  // code copied from ROM
"    ldr     r1, =0x010e1000\n"   // to ram
"    ldr     r3, =0x010fce10\n"
"loc_fc02002a:\n"
"    cmp     r1, r3\n"
"    itt     lo\n"
"    ldrlo   r2, [r0], #4\n"
"    strlo   r2, [r1], #4\n"
"    blo     loc_fc02002a\n"
// Install CreateTask patch
// use memcpy in case source or destination not word aligned

"    ldr     r0, =0x010e1000\n"
"    ldr     r1, =0x0001be10\n"
"    bl      sub_fc13d49a\n"     // cache stuff, function used in loader
"    ldr     r0, =0xfcd575ac\n"  // DATA copied
"    ldr     r1, =0xbfe10800\n"  // to RAM
"    ldr     r3, =0xbfe1751d\n"

"loc_fc020046:\n"
"    cmp     r1, r3\n"
"    itt     lo\n"
"    ldrlo   r2, [r0], #4\n"
"    strlo   r2, [r1], #4\n"
"    blo     loc_fc020046\n"     /// task hook here due to dual ram sugested by reyalp

        "ldr     r0, =hook_CreateTask\n"    // dest: Address to patch (hook_ has thumb bit off)
        "adr     r1, patch_CreateTask\n"    // src: Patch data
        "mov     r2, #8\n" // two words
        "bl      _memcpy\n" // shouldn't need to preserve any extra regs, cache func called just below




   // Install CreateTask patch
   //"adr     r0, patch_CreateTask\n"    // Patch data
//   "ldm     r0, {r1,r2}\n"             // Get two patch instructions
   // reached here ok led lights
   //"BL     blinkinNew\n"
   //"ldr     r0, =hook_CreateTask\n"    // Address to patch (hook_ has thumb bit off)
//   "stm     r0, {r1,r2}\n"             // Store patch instructions
//"BL     blinkinNew\n"



"    ldr     r0, =0xfcd1088c\n"      // this is new in 720 data copy to?
"    ldr     r1, =0x00008000\n"
"    ldr     r3, =0x00032f10\n"
"loc_fc02005a:\n"
"    cmp     r1, r3\n"
"    itt     lo\n"
"    ldrlo   r2, [r0], #4\n"
"    strlo   r2, [r1], #4\n"
"    blo     loc_fc02005a\n"
"    ldr     r3, =0x00032f10\n"
"    ldr     r1, =0x00395364\n" //  *"dS9"
"    mov.w   r2, #0\n"
"loc_fc020070:\n"         // some extra in SX720 vs d7x
// with out 4 lines patch.... reach here
"    cmp     r3, r1\n"
"    it      lo\n"
"    strlo   r2, [r3], #4\n"
"    blo     loc_fc020070\n"
//"BL     blinkinNew\n"
//"BL     blinkoutNew\n"
//"    b.w     sub_fc05b1f8\n"  // in dx7 was  sub_fc064300_my\n"   DISABLE IT starts and ends with it
"    b.w     sub_fc05b1f8_my\n"  // in dx7 was  sub_fc064300_my\n"
// New srsa_4c to align code
    ".align  2\n"                       // target is unaligned, the following needs to be unaligned as well
    ".hword  0\n"                       // dummy halfword
   "patch_CreateTask:\n"
    "ldr.w   pc, _createtask_my\n"      // Do jump to absolute address CreateTask_my
   "_createtask_my:\n"
    ".long   CreateTask_my + 1\n"       // has to be a thumb address
    ".align 1\n"


//   "patch_CreateTask:\n"
//    "ldr.w   pc, [pc,#0]\n"             // Do jump to absolute address CreateTask_my
//    ".long   CreateTask_my + 1\n"           // has to be a thumb address
);
}  // SX 720 completed

/*************************************************************/
void __attribute__((naked,noinline)) CreateTask_my() {
asm volatile (
"    push   {r0}\n"								// Copied from G7x maybe wrong regs double check
//R3 = Pointer to task function to create
//"BL     blinkinNew\n"

// ENABLE

"    ldr     r0, =task_CaptSeq\n"       // DryOS original code function ptr.
"    cmp     r0, r3\n"                  // is the given taskptr equal to our searched function?
"    itt     eq\n"                      // EQ block
"    ldreq   r3, =capt_seq_task\n"      // if so replace with our task function base ptr.
"    orreq   r3, #1\n"                  // make sure it's a thumb address (may not be needed?)
"    beq     exitHook\n"                // below compares not necessary if this check has found something.


/*
"    LDR     R0, =task_ExpDrv\n"
"    CMP     R0, R3\n"
"    itt     eq\n"
"    LDREQ   R3, =exp_drv_task\n"
"    orreq   r3, #1\n"
"    BEQ     exitHook\n"

"    LDR     R0, =task_DvlpSeqTask\n"
"    CMP     R0, R3\n"
"    itt     eq\n"
"    LDREQ   R3, =developseq_task\n"
"    orreq   r3, #1\n"
"    BEQ     exitHook\n"


"    LDR     R0, =task_FileWrite\n"
"    CMP     R0, R3\n"
"    LDREQ   R3, =filewritetask\n"
"    BEQ     exitHook\n"

"    LDR     R0, =task_MovieRecord\n"
"    CMP     R0, R3\n"
"    LDREQ   R3, =movie_record_task\n"
"    BEQ     exitHook\n"
*/
// ENABLE

"    ldr     r0, =task_InitFileModules\n"
"    cmp     r0, r3\n"
"    itt     eq\n"
"    ldreq   r3, =init_file_modules_task\n"
"    orreq   r3, #1\n"

"exitHook:\n"
// restore overwritten register(s)
"    pop    {r0}\n"
// Execute overwritten instructions from original code, then jump to firmware  modified to SX720
"    stmdb   sp!, {r1, r2, r3, r4, r5, r6, r7, lr}\n"  // modified to SX720 but was push instead pos push.w in g7x
"    mov     r5, r2\n" // modified to SX720
"    ldr     r2, =0x00008164\n"  // modified to SX720
//"    ldr     r2, =0x8164\n"  // modified to SX720
"    mov     r4, r3\n" // modified to SX720
"    ldr.w   pc, =(hook_CreateTask + 8 + 1) \n"  // Continue in firmware (thumb bit set)
".ltorg\n"
);
} // modified to SX720 untested

void __attribute__((naked,noinline)) sub_fc05b1f8_my() {   // in g7x was  sub_fc064300_my
// no GPIO checks needed with 0x12345678 set, native fw handles long press
    asm volatile (
"    push    {r4, lr}\n"


#if defined(CHDK_NOT_IN_CANON_HEAP)
"    ldr     r4, =0x00395364\n"         // heap start, modify here  SX 720 modified in g7x was 0x0036a354
#else
    "ldr     r4, =new_sa\n"             // +
    "ldr     r4, [r4]\n"                // +
#endif
"    sub     sp, #0x78\n"
"    ldr     r0, =0x006ce000\n"
"    ldr     r1, =0x000b1fec\n"      // sx720
"    subs    r0, r0, r4\n"
"    cmp     r0, r1\n"
"    bhs     loc_fc05b20a\n"     // sx720
//"BL     blinkinNew\n" // here fails led do not light
//"BL     blinkoutNew\n" // here fails led do not light
//"BL     blinkinNew\n"
"loc_fc05b208:\n"
"    b       loc_fc05b208\n"
"loc_fc05b20a:\n"				 // sx720
"    ldr     r1, =0x00008078\n"
"    mov.w   r0, #0x80000\n"
"    str     r0, [r1]\n"
"    ldr     r1, =0x0000807c\n"
"    ldr     r0, =0x42281000\n"
"    str     r0, [r1]\n"
"    ldr     r1, =0x00008080\n"
"    ldr     r0, =0x42283000\n"
"    str     r0, [r1]\n"
"    movs    r1, #0x78\n"
"    mov     r0, sp\n"
"    blx     sub_fc2ed834\n" // j_bzero
"    ldr     r0, =0x0060e000\n"
"    mov.w   r1, #0xc0000\n"
"    stm.w   sp, {r0, r1, r4}\n"
"    ldr     r1, =0x00600014\n"
"    subs    r2, r1, r4\n"
"    strd    r2, r1, [sp, #0xc]\n"
"    str     r0, [sp, #0x14]\n"
"    movs    r0, #0x22\n"
"    str     r0, [sp, #0x18]\n"
"    movs    r0, #0xca\n"
"    str     r0, [sp, #0x1c]\n"
"    movw    r0, #0x2b0\n"
"    str     r0, [sp, #0x20]\n"
"    movs    r0, #0xfa\n"
"    str     r0, [sp, #0x24]\n"
"    movw    r0, #0x11a\n"
"    str     r0, [sp, #0x28]\n"
"    movs    r0, #0x85\n"
"    str     r0, [sp, #0x2c]\n"
"    movs    r0, #0x40\n"
"    str     r0, [sp, #0x30]\n"
"    movs    r0, #4\n"
"    str     r0, [sp, #0x34]\n"
"    movs    r0, #0\n"
"    str     r0, [sp, #0x38]\n"
"    movs    r0, #0x10\n"
"    str     r0, [sp, #0x5c]\n"
"    movs    r2, #0\n"
"    lsls    r0, r0, #8\n"
"    str     r0, [sp, #0x60]\n"   // Sx720 OK
//"    ldr     r1, =0xfc05b389\n"  // SX 720 in g7x was //"    ldr     r1, =0xfc064491\n"
"    ldr     r1, =sub_fc05b388_my\n"// -> continue here (init_task)   in gx7 was:   sub_fc064490_my
"    asrs    r0, r0, #4\n"
"    str     r0, [sp, #0x64]\n"
"    lsls    r0, r0, #5\n"
"    str     r0, [sp, #0x68]\n"
"    mov     r0, sp\n"
"    blx     sub_fc2ecfa4\n"
"    add     sp, #0x78\n"
"    pop     {r4, pc}\n"   // sx720 Ok
".ltorg\n"
    );
}  // sx720 ok

void __attribute__((naked,noinline)) sub_fc05b388_my() {   // in g7x was sub_fc064490_my
    asm volatile (
"    push    {r4, lr}\n"
//"BL     blinkin\n"  // nothing here??
"    ldr     r4, =0xfc05b430\n" //  *"/_term"  fw add	r4, pc, #164	; 0xfc05b430: (65745f2f)
"    bl      sub_fc05c268\n"
"    ldr     r0, =0x000080f0\n"
"    ldr     r1, [r0]\n"
"    ldr     r0, =0x00008078\n"
"    ldr     r0, [r0]\n"
"    adds    r0, #0x10\n"
"    cmp     r1, r0\n"
"    bhs     loc_fc05b3a4\n"
"    ldr     r0, =0xfc05b440\n" //  *"USER_MEM size checking"
"    bl      sub_fc05b41a\n"
"loc_fc05b3a4:\n"
"    bl      sub_fc0718f4\n"   // disable IRQ sx720
"    ldr     r1, =0xbfe10000\n"
// note capdis bad output also in sx720
//"    mov.w   r2, #-0x11111112\n"
"    mov.w   r2, #0xeeeeeeee\n"   // like in g7x may need check
"    ldr     r3, =0xbfe10800\n"
"loc_fc05b3b0:\n"
"    stm     r1!, {r2}\n"
"    cmp     r1, r3\n"
"    blo     loc_fc05b3b0\n"
"    bl      sub_fc071906\n" // enable IRQ
"    bl      sub_fc427a94\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b3c8\n"
"    ldr     r0, =0xfc05b460\n" //  *"dmSetup"
"    bl      sub_fc05b41a\n"
"loc_fc05b3c8:\n"
"    bl      sub_fc05cae4\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b3d6\n"
"    ldr     r0, =0xfc05b468\n" //  *"termDriverInit"
"    bl      sub_fc05b41a\n"
"loc_fc05b3d6:\n"
"    mov     r0, r4\n"
"    bl      sub_fc05cb72\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b3e6\n"
"    ldr     r0, =0xfc05b478\n" //  *"termDeviceCreate"
"    bl      sub_fc05b41a\n"
"loc_fc05b3e6:\n"
"    mov     r0, r4\n"
"    bl      sub_fc05b5b0\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b3f6\n"
"    ldr     r0, =0xfc05b48c\n" //  *"stdioSetup"
"    bl      sub_fc05b41a\n"
"loc_fc05b3f6:\n"
"    bl      sub_fc05b6f4\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b404\n"
"    ldr     r0, =0xfc05b498\n" //  *"stdlibSetup"
"    bl      sub_fc05b41a\n"
"loc_fc05b404:\n"
"    bl      sub_fc05e5f8\n"
"    cmp     r0, #0\n"
"    bge     loc_fc05b412\n"
"    ldr     r0, =0xfc05b4a4\n" //  *"extlib_setup"
"    bl      sub_fc05b41a\n"
"loc_fc05b412:\n"
"    pop.w   {r4, lr}\n"
//"    b.w     loc_fc05b77e\n"    // in g7x was  loc_fc064896\n"
//"    b.w     sub_fc05b77e\n" //
"    b.w     sub_fc05b77e_my\n"
    ".ltorg\n"
    );
}  // SX720
void __attribute__((naked,noinline)) sub_fc05b77e_my() {   // in g7x was  fc064896_my   The starting code is a bit diferent
    asm volatile (
"    push    {r3, lr}\n"
"    bl      sub_fc05b8ac\n"
"    bl      sub_fc05b7c8\n"
"    bl      sub_fc061534\n" // IsNormalCameraMode_FW
"    bl      sub_fc0a97d4\n"
"    cbnz    r0, loc_fc05b798\n"
"    bl      sub_fc05b89a\n"
// in gx7 was something like , not sure if this will be needed in sx720
//	"    bl      sub_fc0781f4\n" // power-on mode handling & startupchecks here, no override needed with 0x12345678 set
"loc_fc05b796:\n"
"    b       loc_fc05b796\n"
"loc_fc05b798:\n"
"    blx     sub_fc2ecffc\n"
"    ldr     r1, =0x006ce000\n"
"    movs    r0, #0\n"
"    bl      sub_fc348da8\n"
"    movs    r3, #0\n"
"    str     r3, [sp]\n"
// in g7x was   ldr     r3, =0xfc064831\n" //  task_Startup
//"    ldr     r3, =0xfc05b719\n" //  task_Startup
"    ldr     r3, =task_Startup_my\n" //  ->
"    movs    r2, #0\n"
"    movs    r1, #0x19\n"
"    ldr     r0, =0xfc05b7c0\n" //  *"Startup"
"    bl      _CreateTask\n"
//"    blx     sub_fc2ed6e4\n" // j_CreateTask
//in g7x was  "    blx     sub_fc2ef5ac\n" // j_CreateTask
"    movs    r0, #0\n"
"    pop     {r3, pc}\n"
    ".ltorg\n"
    );
} // Sx720

void __attribute__((naked,noinline)) task_Startup_my() {  // at 0xfc05b719  in sx720  in g7x fc064831
    asm volatile (
"    push    {r4, lr}\n"
"    bl      sub_fc0a9bcc\n"  // CreateTask ClockSave
"    bl      sub_fc05b874\n"  // posixSetup etc
//"    bl      sub_fc13d830\n"  // ->nullsub
"    bl      sub_fc428248\n"    // StartWDT ...
//"    bl      sub_fc13d8b6\n"    // StartDiskboot
"    bl      sub_fc0a9ec6\n"
"    bl      sub_fc13d9a8\n"
"    bl      sub_fc05b9e0\n"
"    bl      sub_fc05b95c\n"    // InitExDrivers.c
"    bl      sub_fc42827e\n"
"    bl      sub_fc07a068\n"
"    bl      sub_fc13d9ae\n"
"    bl      sub_fc0a96fa_my\n"   // CreateTask PhySw   in g7x was  sub_fc0780e6_my
"    bl      CreateTask_spytask\n"
"    bl      init_required_fw_features\n" // added
"    bl      sub_fc26e2e4\n"
"    bl      sub_fc13d9c4\n"
"    bl      sub_fc0a8580\n"
"    bl      sub_fc0a910a\n"
"    bl      sub_fc0a9d2e\n"
"    bl      sub_fc08a3a2\n"
"    bl      sub_fc0a90c6\n"
"    bl      sub_fc05b9e4\n"
"    bl      sub_fc2fbc8e\n"
"    bl      sub_fc0a9098\n"
"    pop.w   {r4, lr}\n"
"    b.w     sub_fc0a9ba2\n"  // changed to sub
    ".ltorg\n"
    );
}  // sx 720

// in gx 7 was -f=chdk -s=0xfc0780e7 -c=18
//taskcreate_physw
void __attribute__((naked,noinline)) sub_fc0a96fa_my() {    // in gx 7 was fc0780e6_my
    asm volatile (
"    push    {r3, r4, r5, lr}\n"
"    bl      sub_fc076e84\n"
"    bl      sub_fc0614b2\n" // IsFactoryMode_FW
"    cbnz    r0, loc_fc0a970a\n"
"    bl      sub_fc076e28\n" // OpLog.Start_FW
"loc_fc0a970a:\n"
"    ldr     r4, =0x000082dc\n" //  physw_run
"    ldr     r0, [r4, #4]\n"
"    cmp     r0, #0\n"
"    bne     loc_fc0a9726\n"
"    movs    r3, #0\n"
"    str     r3, [sp]\n"
//"    ldr     r3, =0xfc0a96d5\n" //  task_PhySw
// in gx7 "    ldr     r3, =0xfc0780c1\n" //  task_PhySw
"    ldr     r3, =mykbd_task\n"
"    movs    r1, #0x17\n"
"    ldr     r0, =0xfc0a9a60\n" //  *"PhySw"
//"    movw    r2, #0x800\n"
"    movw    r2, #0x2000\n" // adjusted 0x800 -> 0x2000   like in g7x ?
"    blx     sub_fc2ed6e4\n" // j_CreateTask
"    str     r0, [r4, #4]\n"
"loc_fc0a9726:\n"
"    pop     {r3, r4, r5, pc}\n"
    ".ltorg\n"
    );
}  // sx720

// -f=chdk -s=task_InitFileModules -c=16   in sx720 0xfc587169
void __attribute__((naked,noinline)) init_file_modules_task() {
    asm volatile (
"    push    {r4, r5, r6, lr}\n"
"    movs    r0, #6\n"
"    bl      sub_fc2fb408\n"
"    bl      sub_fc0b7514\n"  // one not in g7x
"    movs    r4, r0\n"
"    movw    r5, #0x5006\n"
"    beq     loc_fc587184\n"
"    movs    r1, #0\n"
"    mov     r0, r5\n"
"    bl      _PostLogicalEventToUI\n"
"loc_fc587184:\n"
"    bl      sub_fc0b753e\n"
"    BL      core_spytask_can_start\n" // + CHDK: Set "it's-safe-to-start" flag for spytask
"    cmp     r4, #0\n"
"    bne     loc_fc587198\n"
"    mov     r0, r5\n"
"    pop.w   {r4, r5, r6, lr}\n"
"    movs    r1, #1\n"
"    b.w     _PostLogicalEventToUI\n"
"loc_fc587198:\n"
"    pop     {r4, r5, r6, pc}\n"
    ".ltorg\n"
    );
}  // sx 720
/*
    *** TEMPORARY? workaround ***   Left in sx720 uncheckd
    Init stuff to avoid asserts on cameras running DryOS r54+
    https://chdk.setepontos.com/index.php?topic=12516.0
    Execute this only once
 */
void init_required_fw_features(void) {
    extern void _init_focus_eventflag();
    extern void _init_nd_eventflag();
//    extern void _init_nd_semaphore();
    //extern void _init_zoom_semaphore(); // for MoveZoomLensWithPoint

    _init_focus_eventflag();
    _init_nd_eventflag();
    // for MoveIrisWithAv, based on fc3d1a74 (but without registers eventprocs)
    extern int av_override_semaphore;
    extern int _CreateBinarySemaphoreStrictly(int x, int y);
    av_override_semaphore = _CreateBinarySemaphoreStrictly(0,0);
//    _init_nd_semaphore();
}

// jogdial override code called from kbd task
// -f=chdk -s=kbd_p2_f -c=77
// SX720 is 0xfc0a9431 G7x was: kbd_p2_f 0xfc077e8d
void __attribute__((naked,noinline)) kbd_p2_f_my() {
    asm volatile(
"    push.w  {r4, r5, r6, r7, r8, lr}\n"
"    ldr     r6, =0x0003480c\n"
"    sub     sp, #0x18\n"
"    add     r7, sp, #8\n"
"    subs    r6, #0xc\n"
"    b       loc_fc0a9472\n"
"loc_fc0a943e:\n"
"    ldr     r1, =0x0003480c\n"
"    add     r3, sp, #8\n"
"    ldrb.w  r0, [sp, #4]\n"
"    add     r2, sp, #0x14\n"
"    subs    r1, #0x18\n"
"    bl      sub_fc072c5e\n"
"    cbnz    r0, loc_fc0a9458\n"
"    ldr     r1, [sp, #0x14]\n"
"    movs    r0, #0\n"
"    bl      sub_fc0a93a2\n"
"loc_fc0a9458:\n"
"    movs    r0, #2\n"
"loc_fc0a945a:\n"
"    ldr.w   r1, [r7, r0, lsl #2]\n"
"    cbz     r1, loc_fc0a946a\n"
"    ldr.w   r2, [r6, r0, lsl #2]\n"
"    bics    r2, r1\n"
"    str.w   r2, [r6, r0, lsl #2]\n"
"loc_fc0a946a:\n"
"    subs    r0, r0, #1\n"
"    sxtb    r0, r0\n"
"    cmp     r0, #0\n"
"    bge     loc_fc0a945a\n"
"loc_fc0a9472:\n"
"    ldr     r0, =0x0003480c\n"
"    add     r1, sp, #4\n"
"    subs    r0, #0xc\n"
"    bl      sub_fc072992\n"
"    cmp     r0, #0\n"
"    bne     loc_fc0a943e\n"
"    ldr.w   r8, =0x0003480c\n"
"    movs    r4, #0\n"
"loc_fc0a9486:\n"
"    movs    r5, #0\n"
"    ldr.w   r0, [r6, r4, lsl #2]\n"
"    ldr.w   r1, [r8, r4, lsl #2]\n"
"    ands    r0, r1\n"
"    str.w   r0, [r6, r4, lsl #2]\n"
"    b       loc_fc0a94de\n"
"loc_fc0a9498:\n"
"    lsrs    r0, r5\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0a94d6\n"
"    ldr     r1, =0x0003480c\n"
"    add.w   r0, r5, r4, lsl #5\n"
"    add     r3, sp, #8\n"
"    subs    r1, #0x18\n"
"    add     r2, sp, #0x14\n"
"    uxtb    r0, r0\n"
"    bl      sub_fc072c5e\n"
"    cbnz    r0, loc_fc0a94ba\n"
"    ldr     r1, [sp, #0x14]\n"
"    movs    r0, #1\n"
"    bl      sub_fc0a93a2\n"
"loc_fc0a94ba:\n"
"    mov     r0, r4\n"
"    b       loc_fc0a94d2\n"
"loc_fc0a94be:\n"
"    ldr.w   r1, [r7, r0, lsl #2]\n"
"    cbz     r1, loc_fc0a94ce\n"
"    ldr.w   r2, [r6, r0, lsl #2]\n"
"    bics    r2, r1\n"
"    str.w   r2, [r6, r0, lsl #2]\n"
"loc_fc0a94ce:\n"
"    adds    r0, r0, #1\n"
"    sxtb    r0, r0\n"
"loc_fc0a94d2:\n"
"    cmp     r0, #3\n"
"    blt     loc_fc0a94be\n"
"loc_fc0a94d6:\n"
"    ldr.w   r0, [r6, r4, lsl #2]\n"
"    adds    r5, r5, #1\n"
"    uxtb    r5, r5\n"
"loc_fc0a94de:\n"
"    cmp     r0, #0\n"
"    bne     loc_fc0a9498\n"
"    adds    r4, r4, #1\n"
"    sxtb    r4, r4\n"
"    cmp     r4, #3\n"
"    blt     loc_fc0a9486\n"
"    bl      sub_fc072758_my\n"   // ->  in Gx7 was sub_fc075c6e_my
"    add     sp, #0x18\n"
"    pop.w   {r4, r5, r6, r7, r8, pc}\n"
".ltorg\n"
    );
} // SX720

// SX720 is fc072758  GX7 was:   -f=chdk -s=0xfc075c6f -c=13
void __attribute__((naked,noinline)) sub_fc072758_my() {   //in Gx7 was sub_fc075c6e_my
    asm volatile(
"    push    {r4, lr}\n"
"    ldr     r4, =0x00009814\n"
"    ldr     r0, [r4, #8]\n"
"    bl      sub_fc077094\n"
"    bl      sub_fc19e650\n"
"    ldr     r0, [r4, #0xc]\n"
"    bl      sub_fc076fc4\n"
// re-ordered
//"    pop.w   {r4, lr}\n"
//"    b.w     loc_fc08581e\n"
"    bl      handle_jogdial\n"  // +
"    cmp     r0, #0\n"          // +
"    beq     no_scroll\n"       // +
"    bl      sub_fc08581e\n"    // handles scrollwheel(s), void function, no args
"no_scroll:\n"                  // +
"    pop     {r4, pc}\n"        // +
".ltorg\n"
    ); // SX720
}
