#include "lolevel.h"
#include "platform.h"
#include "core.h"

// TODO dummy   left in SX720 unchecked
static long fake_nrflag=0;
static long *nrflag=&fake_nrflag;
// NOTE sx280hs had
//#define NR_AUTO (0) // not needed (in fact, it makes the camera crash)

extern int active_raw_buffer;
// debug
extern void _LogCameraEvent(int id,const char *fmt,...);

extern char *hook_raw_image_addr(void);

void log_capt_seq(int m)   // 0x60 will be the same for sx720 ??
{
    _LogCameraEvent(0x60,"cs m:%d arb:%d rb:0x%08x i:%04d",
                    m,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}
void log_capt_seq2(int m)
{
    _LogCameraEvent(0x60,"cs end m:%d arb:%d rb:0x%08x i:%04d",
                    m,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}
void log_capt_seq_override(void)
{
    _LogCameraEvent(0x60,"cs override arb:%d rb:0x%08x i:%04d",
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}

#include "../../../generic/capt_seq.c"
//-s=task_CaptSeq -c=173 -f=chdk
// task_CaptSeq 0xfc0b260b   in g7x was  0xfc1501d9
void __attribute__((naked,noinline)) capt_seq_task() {
    asm volatile (
"    push    {r3, r4, r5, r6, r7, lr}\n"
"    ldr     r4, =0x0003ce08\n"
"    movs    r6, #0\n"
"    ldr     r5, =0x0000bc40\n"
"loc_fc0b2612:\n"
"    movs    r2, #0\n"
"    mov     r1, sp\n"
"    ldr     r0, [r5, #8]\n"
"    blx     sub_fc2ed70c\n" // j_ReceiveMessageQueue
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0b2634\n"
"    movw    r2, #0x434\n"
"    ldr     r1, =0xfc0b22e4\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"    blx     sub_fc2ed71c\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"
"loc_fc0b2634:\n"
"    ldr     r0, [sp]\n"
"    ldr     r0, [r0]\n"
"    cmp     r0, #1\n"
"    beq     loc_fc0b264c\n"
"    cmp     r0, #0x2b\n"
"    beq     loc_fc0b264c\n"
"    cmp     r0, #0x1f\n"
"    beq     loc_fc0b264c\n"
"    cmp     r0, #0x23\n"
"    beq     loc_fc0b264c\n"
"    bl      sub_fc1b8264\n"
"loc_fc0b264c:\n"
// debug message
"ldr     r0, [sp]\n"
"ldr     r0, [r0]\n"
"bl log_capt_seq\n"
"    ldr     r0, [sp]\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #0x34\n"
"    bhs     loc_fc0b2736\n"
"    tbb     [pc, r1]\n" // (jumptable r1 52 elements)
"branchtable_fc0b2658:\n"
"    .byte((loc_fc0b268c - branchtable_fc0b2658) / 2)\n" // (case 0)
"    .byte((loc_fc0b26a2 - branchtable_fc0b2658) / 2)\n" // (case 1)
"    .byte((loc_fc0b26aa - branchtable_fc0b2658) / 2)\n" // (case 2)
"    .byte((loc_fc0b26b8 - branchtable_fc0b2658) / 2)\n" // (case 3)
"    .byte((loc_fc0b26b2 - branchtable_fc0b2658) / 2)\n" // (case 4)
"    .byte((loc_fc0b26c2 - branchtable_fc0b2658) / 2)\n" // (case 5)
"    .byte((loc_fc0b26c8 - branchtable_fc0b2658) / 2)\n" // (case 6)
"    .byte((loc_fc0b26d2 - branchtable_fc0b2658) / 2)\n" // (case 7)
"    .byte((loc_fc0b26da - branchtable_fc0b2658) / 2)\n" // (case 8)
"    .byte((loc_fc0b26ea - branchtable_fc0b2658) / 2)\n" // (case 9)
"    .byte((loc_fc0b26f2 - branchtable_fc0b2658) / 2)\n" // (case 10)
"    .byte((loc_fc0b26f8 - branchtable_fc0b2658) / 2)\n" // (case 11)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 12)
"    .byte((loc_fc0b2700 - branchtable_fc0b2658) / 2)\n" // (case 13)
"    .byte((loc_fc0b2706 - branchtable_fc0b2658) / 2)\n" // (case 14)
"    .byte((loc_fc0b2718 - branchtable_fc0b2658) / 2)\n" // (case 15)
"    .byte((loc_fc0b271e - branchtable_fc0b2658) / 2)\n" // (case 16)
"    .byte((loc_fc0b2724 - branchtable_fc0b2658) / 2)\n" // (case 17)
"    .byte((loc_fc0b272a - branchtable_fc0b2658) / 2)\n" // (case 18)
"    .byte((loc_fc0b2730 - branchtable_fc0b2658) / 2)\n" // (case 19)
"    .byte((loc_fc0b2738 - branchtable_fc0b2658) / 2)\n" // (case 20)
"    .byte((loc_fc0b273e - branchtable_fc0b2658) / 2)\n" // (case 21)
"    .byte((loc_fc0b2742 - branchtable_fc0b2658) / 2)\n" // (case 22)
"    .byte((loc_fc0b2748 - branchtable_fc0b2658) / 2)\n" // (case 23)
"    .byte((loc_fc0b274e - branchtable_fc0b2658) / 2)\n" // (case 24)
"    .byte((loc_fc0b2754 - branchtable_fc0b2658) / 2)\n" // (case 25)
"    .byte((loc_fc0b275a - branchtable_fc0b2658) / 2)\n" // (case 26)
"    .byte((loc_fc0b2760 - branchtable_fc0b2658) / 2)\n" // (case 27)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 28)
"    .byte((loc_fc0b2768 - branchtable_fc0b2658) / 2)\n" // (case 29)
"    .byte((loc_fc0b276e - branchtable_fc0b2658) / 2)\n" // (case 30)
"    .byte((loc_fc0b2772 - branchtable_fc0b2658) / 2)\n" // (case 31)
"    .byte((loc_fc0b277a - branchtable_fc0b2658) / 2)\n" // (case 32)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 33)
"    .byte((loc_fc0b2780 - branchtable_fc0b2658) / 2)\n" // (case 34)
"    .byte((loc_fc0b2786 - branchtable_fc0b2658) / 2)\n" // (case 35)
"    .byte((loc_fc0b278c - branchtable_fc0b2658) / 2)\n" // (case 36)
"    .byte((loc_fc0b2792 - branchtable_fc0b2658) / 2)\n" // (case 37)
"    .byte((loc_fc0b2798 - branchtable_fc0b2658) / 2)\n" // (case 38)
"    .byte((loc_fc0b27a0 - branchtable_fc0b2658) / 2)\n" // (case 39)
"    .byte((loc_fc0b27a6 - branchtable_fc0b2658) / 2)\n" // (case 40)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 41)
"    .byte((loc_fc0b27ca - branchtable_fc0b2658) / 2)\n" // (case 42)
"    .byte((loc_fc0b27d0 - branchtable_fc0b2658) / 2)\n" // (case 43)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 44)
"    .byte((loc_fc0b27f0 - branchtable_fc0b2658) / 2)\n" // (case 45)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 46)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 47)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 48)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 49)
"    .byte((loc_fc0b27e2 - branchtable_fc0b2658) / 2)\n" // (case 50)
"    .byte((loc_fc0b27dc - branchtable_fc0b2658) / 2)\n" // (case 51)
".align 1\n"
"loc_fc0b268c:\n" // case 0: preshoot, quick press shoot
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc0b2ba8\n"
"bl log_capt_seq_override\n"
"    BL      shooting_expo_param_override\n" // +
"    bl      sub_fc0b05f8\n"
"    ldr     r0, [r4, #0x28]\n"
"    cmp     r0, #0\n"
"    beq     loc_fc0b26a0\n"
"    bl      sub_fc0f2464_my\n"  // -> nr?, remote hook, raw hook (quick, no half press)  in g7x was sub_fc1e58d8_my
"loc_fc0b26a0:\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26a2:\n"  // case 1: (normal shoot)
"    ldr     r0, [r0, #0x10]\n"
"    bl      sub_fc0f2404_my\n"     // ->  nr?, remote hook, raw hook   in gx was sub_fc1e56a6_my
"    b       loc_fc0b27f0\n"
"loc_fc0b26aa:\n"
"    movs    r0, #1\n"
"    bl      sub_fc0b2e9e\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26b2:\n"
"    bl      sub_fc0b28ee\n"
"    b       loc_fc0b26be\n"
"loc_fc0b26b8:\n"
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc0b2b90\n"
"loc_fc0b26be:\n"
"    str     r6, [r4, #0x28]\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26c2:\n"
"    bl      sub_fc0b2b96\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26c8:\n"
"    bl      sub_fc0b2dc4\n"
"    bl      sub_fc0b05f8\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26d2:\n"
"    ldr     r0, [r0, #0x10]\n"
"    bl      sub_fc0f2508\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26da:\n"
"    bl      sub_fc0b2e26\n"
"    bl      sub_fc0b05f8\n"
"    movs    r0, #0\n"
"    bl      sub_fc26e0f4\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26ea:\n"
"    ldr     r0, [r4, #0x54]\n"
"    bl      sub_fc0b3532\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b26f2:\n"
"    bl      sub_fc0b37d8\n"
"    b       loc_fc0b27f0\n"
// NO litral pool in sx720 like in g7x
//".ltorg\n"
// firmware had literal pool here
/*
fcd0 0003
fad4 0003
bd84 0000
*/
"loc_fc0b26f8:\n"
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc0b3824\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2700:\n"
"    bl      sub_fc0b397a\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2706:\n"
"    bl      sub_fc0b3d4a\n"
"    b       loc_fc0b27f0\n"
"    beq     loc_fc0b2740\n"
"    movs    r3, r0\n"    // this was no it g7x mabe like removed literal at fc1502ba in gx7 needs check
"    ldm     r6!, {r3}\n"
"    movs    r3, r0\n"
"    pop     {r6}\n"
"    movs    r0, r0\n"
"loc_fc0b2718:\n"
"    bl      sub_fc0b3de0\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b271e:\n"
"    bl      sub_fc0f17b4\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2724:\n"
"    bl      sub_fc0f1950\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b272a:\n"
"    bl      sub_fc0f19ce\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2730:\n"
"    bl      sub_fc0f1a6c\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2736:\n"
"    b       loc_fc0b27e2\n"
"loc_fc0b2738:\n"
"    bl      sub_fc0f1b24\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b273e:\n"
"    movs    r0, #0\n"
"loc_fc0b2740:\n"
"    b       loc_fc0b2762\n"
"loc_fc0b2742:\n"
"    bl      sub_fc0f1e46\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2748:\n"
"    bl      sub_fc0f1ea6\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b274e:\n"
"    bl      sub_fc0f1eaa\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2754:\n"
"    bl      sub_fc0f1ebc\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b275a:\n"
"    bl      sub_fc0f1f40\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2760:\n"
"    movs    r0, #1\n"
"loc_fc0b2762:\n"
"    bl      sub_fc0f1d24\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2768:\n"
"    bl      sub_fc0b2f80\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b276e:\n"
"    movs    r0, #0\n"
"    b       loc_fc0b2774\n"
"loc_fc0b2772:\n"
"    ldr     r0, [r0, #0xc]\n"
"loc_fc0b2774:\n"
"    bl      sub_fc0b3010\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b277a:\n"
"    bl      sub_fc0f1c48\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2780:\n"
"    bl      sub_fc0f1cb4\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2786:\n"
"    bl      sub_fc0f2684\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b278c:\n"
"    bl      sub_fc2c1f66\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2792:\n"
"    bl      sub_fc2c2020\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b2798:\n"
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc0f201c\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b27a0:\n"
"    bl      sub_fc0f2084\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b27a6:\n"
"    bl      sub_fc0b565c\n"
"    ldrh.w  r0, [r4, #0x1a8]\n"
"    cmp     r0, #4\n"
"    beq     loc_fc0b27bc\n"
"    ldrh    r0, [r4]\n"
"    sub.w   r1, r0, #0x4200\n"
"    subs    r1, #0x37\n"
"    bne     loc_fc0b27f0\n"
"loc_fc0b27bc:\n"
"    bl      sub_fc2c2020\n"
"    bl      sub_fc2c255c\n"
"    bl      sub_fc2c23ba\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b27ca:\n"
"    movs    r2, #0\n"
"    movs    r1, #0x11\n"
"    b       loc_fc0b27d4\n"
"loc_fc0b27d0:\n"
"    movs    r2, #0\n"
"    movs    r1, #0x10\n"
"loc_fc0b27d4:\n"
"    movs    r0, #0\n"
"    bl      sub_fc0b11b8\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b27dc:\n"
"    bl      sub_fc0b347e\n"
"    b       loc_fc0b27f0\n"
"loc_fc0b27e2:\n"
"    movw    r2, #0x563\n"
"    ldr     r1, =0xfc0b22e4\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc0b27f0:\n"
// debug after message handled
"ldr     r0, [sp]\n"
"ldr     r0, [r0]\n"
"bl log_capt_seq2\n"
"    ldr     r0, [sp]\n"
"    ldr     r1, [r0, #4]\n"
"    ldr     r0, [r5, #4]\n"
"    blx     sub_fc2ed754\n" // j_SetEventFlag
"    ldr     r7, [sp]\n"
"    ldr     r0, [r7, #8]\n"
"    cbnz    r0, loc_fc0b280c\n"
"    movs    r2, #0xff\n"
"    ldr     r1, =0xfc0b22e4\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc0b280c:\n"
"    str     r6, [r7, #8]\n"
"    b       loc_fc0b2612\n"
".ltorg\n"
    );
}  // sx720 done

//   fc0f2464 in sx720 in g7x was -s=0xfc1e58d9 -c=56 -f=chdk
void __attribute__((naked,noinline)) sub_fc0f2464_my() {  // in g7x was  fc1e58d8_my
    asm volatile (
"    push    {r3, r4, r5, r6, r7, lr}\n"
"    bl      sub_fc0b1d6c\n"
"    mov     r4, r0\n"
"    movs    r0, #0xc\n"
"    bl      sub_fc2eb5c0\n"
"    ldr     r6, =0x000149b8\n"
"    lsls    r0, r0, #0x1f\n"
"    mov.w   r5, #1\n"
"    bne     loc_fc0f24f8\n"
"    movs    r2, #2\n"
"    mov     r1, sp\n"
"    movw    r0, #0x113\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0f2498\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1b4\n"
"    ldr     r1, =0xfc0f25c8\n" //  *"SsCaptureCtrl.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc0f2498:\n"
"    ldrsh.w r0, [sp]\n"
"    bl      sub_fc0a9078\n"
"    bl      sub_fc0a8e26\n"
"    cmp     r0, #1\n"
"    bls     loc_fc0f24fc\n"
"    movs    r0, #0\n"
"    bl      sub_fc0a8f3e\n"
"    bl      sub_fc1603bc\n"
"    bl      sub_fc0b2b9c\n"
"    mov     r0, r4\n"
"    bl      sub_fc152340\n"
"    mov     r1, r4\n"
"    bl      sub_fc15239e\n"
"    movs    r2, #4\n"
"    movw    r0, #0x119\n"
"    add.w   r1, r4, #0x5c\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x32\n"
"    add.w   r1, r4, #0x60\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x46\n"
"    add.w   r1, r4, #8\n"
"    bl      _SetPropertyCase\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b7532\n"
"    mov     r0, r4\n"
//"    bl      sub_fc38dbf4\n"
"    bl      sub_fc38dbf4_my\n"  //  remote hook, raw hook  in g7x was   fc3d3872_my
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0f24fa\n"
"loc_fc0f24f8:\n"
"    str     r5, [r6]\n"
"loc_fc0f24fa:\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"
"loc_fc0f24fc:\n"
"    str     r5, [r6]\n"
"    bl      sub_fc0b0ed4\n"
"    bl      sub_fc2eb5f8\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"
".ltorg\n"
    );
}  // sx720

//in sx720 fc0f2404 in gx7 was  -s=0xfc1e56a7 -c=211 -f=chdk
void __attribute__((naked,noinline)) sub_fc0f2404_my() {   // in g7x was  fc1e56a6_my
    asm volatile (
"    push    {r4, r5, r6, lr}\n"
"    ldr     r5, =0x0003ce08\n"
"    movs    r4, #0\n"
"    mov     r6, r0\n"
"    movw    r0, #0x120\n"
"    ldr     r1, [r5, #0x28]\n"
"    cbz     r1, loc_fc0f243a\n"
"    ldr.w   r2, [r6, #0x124]\n"
"    ldr     r1, =0xfc0f25e0\n" //  *"CaptCtrl:Quick(%d)"
"    bl      sub_fc341712\n" // LogCameraEvent
"    ldr     r0, =0x000149b8\n"
"    ldr     r0, [r0]\n"
"    cbz     r0, loc_fc0f2426\n"
"    movs    r4, #0x1d\n"
"loc_fc0f2426:\n"
"    mov     r2, r6\n"
"    movs    r1, #2\n"
"    mov     r0, r4\n"
"    bl      sub_fc0b11b8\n"
"    mov     r1, r4\n"
"    mov     r0, r6\n"
"    bl      sub_fc1b80c0\n"
"    b       loc_fc0f245e\n"
"loc_fc0f243a:\n"
"    ldr     r1, =0xfc0f25f8\n" //  *"CaptCtrl:ExecCapt"
"    bl      sub_fc341712\n" // LogCameraEvent
"    mov     r0, r6\n"
"    bl      sub_fc0f227a\n"
"    mov     r4, r0\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0f245e\n"
"    movs    r1, #2\n"
"    mov     r2, r6\n"
"    mov     r0, r4\n"
"    bl      sub_fc0b11b8\n"
"    mov     r1, r4\n"
"    mov     r0, r6\n"
"    bl      sub_fc1b81f6\n"
"loc_fc0f245e:\n"
"    movs    r0, #0\n"
"    str     r0, [r5, #0x28]\n"
"    pop     {r4, r5, r6, pc}\n"
"loc_fc0f2464:\n"
"    push    {r3, r4, r5, r6, r7, lr}\n"
"    bl      sub_fc0b1d6c\n"
"    mov     r4, r0\n"
"    movs    r0, #0xc\n"
"    bl      sub_fc2eb5c0\n"
"    ldr     r6, =0x000149b8\n"
"    lsls    r0, r0, #0x1f\n"
"    mov.w   r5, #1\n"
"    bne     loc_fc0f24f8_new\n" /// added _new to build
"    movs    r2, #2\n"
"    mov     r1, sp\n"
"    movw    r0, #0x113\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0f2498_new\n" //new to add the _new to build
"    movs    r0, #0\n"
"    movw    r2, #0x1b4\n"
"    ldr     r1, =0xfc0f25c8\n" //  *"SsCaptureCtrl.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
// here starts the diferences with gx7
"loc_fc0f2498_new:\n"
"    ldrsh.w r0, [sp]\n"
"    bl      sub_fc0a9078\n"
"    bl      sub_fc0a8e26\n"  // battery related?
"    cmp     r0, #1\n"

"    bls     loc_fc0f24fc\n"
"    movs    r0, #0\n"
"    bl      sub_fc0a8f3e\n"
"    bl      sub_fc1603bc\n"
"    bl      sub_fc0b2b9c\n"
"    mov     r0, r4\n"
"    bl      sub_fc152340\n"
"    mov     r1, r4\n"
"    bl      sub_fc15239e\n"
"    movs    r2, #4\n"
"    movw    r0, #0x119\n"
"    add.w   r1, r4, #0x5c\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x32\n"
"    add.w   r1, r4, #0x60\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x46\n"
"    add.w   r1, r4, #8\n"
"    bl      _SetPropertyCase\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b7532\n"
"    mov     r0, r4\n"
"    bl      sub_fc38dbf4_my\n"   // remote hook, raw hook  in g7x was   fc3d3872_my
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc0f24fa_new\n"  // added new to build
"loc_fc0f24f8_new:\n"
"    str     r5, [r6]\n"
"loc_fc0f24fa_new:\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"   // should probably end here in SX720
".ltorg\n"
    );
}  // SX720

/*
void log_nr_call(void) {
    _LogCameraEvent(0x60,"nr call");
}
*/
void log_remote_hook(void) {
    _LogCameraEvent(0x60,"remote hook");        // Left like in g7x mabe be wrong for SX720
}
void log_rh(void) {
    _LogCameraEvent(0x60,"raw hook");
}
/*
void log_p1(void) {
    _LogCameraEvent(0x60,"p1");
}
void log_p2(void) {
    _LogCameraEvent(0x60,"p2");
}
void log_t1(void) {
    _LogCameraEvent(0x60,"t1");
}
void log_t2(void) {
    _LogCameraEvent(0x60,"t2");
}
void log_t3(void) {
    _LogCameraEvent(0x60,"t3");
}
void log_t4(void) {
    _LogCameraEvent(0x60,"t4");
}
void log_t5(void) {
    _LogCameraEvent(0x60,"t5");
}
*/
//   fc38dbf4_my in SX720 in g7x was: -s=0xfc3d3873 -e=0xfc3d3ac8 -f=chdk
void __attribute__((naked,noinline)) sub_fc38dbf4_my() {   // in g7x was fc3d3872_my
    asm volatile (
"    push.w  {r0, r1, r2, r3, r4, r5, r6, r7, r8, sb, sl, lr}\n"
"    mov     r4, r0\n"
"    bl      sub_fc1523f2\n"
"    ldr     r7, =0x0003ce08\n"
"    ldr.w   r0, [r7, #0x170]\n"
"    cbz     r0, loc_fc38dc14\n"
"    ldrh.w  r0, [r7, #0x1a6]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc38dc14\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc38dc1e\n"
"loc_fc38dc14:\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b747e\n"
"    bl      sub_fc1b7bc8\n"
"loc_fc38dc1e:\n"
"    ldr.w   r0, [r7, #0xa0]\n"
"    cbnz    r0, loc_fc38dc3c\n"
"    ldrh.w  r0, [r7, #0x1a6]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc38dc32\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc38dc3c\n"
"loc_fc38dc32:\n"
"    movs    r0, #1\n"
"    bl      sub_fc0b2fa2\n"
"    bl      sub_fc1b778e\n"
"loc_fc38dc3c:\n"
"    movs    r2, #4\n"
"    movw    r0, #0x13a\n"
"    add     r1, sp, #0xc\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc38dc58\n"
"    movs    r0, #0\n"
"    movw    r2, #0x187\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38dc58:\n"
"    ldr     r0, [sp, #0xc]\n"
"    ubfx    r0, r0, #8, #8\n"
"    cmp     r0, #6\n"
"    bne     loc_fc38dc68\n"
"    ldr     r0, =0xfc38dbf1\n"
"    movs    r1, #0\n"
"    b       loc_fc38dc6c\n"
"loc_fc38dc68:\n"
"    ldr     r0, =0xfc1b70f9\n"
"    mov     r1, r4\n"
"loc_fc38dc6c:\n"
"    bl      sub_fc15e020\n"
"    movs    r2, #2\n"
"    movw    r0, #0x115\n"
"    add     r1, sp, #8\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc38dc8c\n"
"    movs    r0, #0\n"
"    movw    r2, #0x190\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38dc8c:\n"
"    ldr.w   r0, [r7, #0x10c]\n"
"    cbz     r0, loc_fc38dcbe\n"
"    ldrh.w  r0, [r7, #0x1a6]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc38dca0\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc38dcbe\n"
"loc_fc38dca0:\n"
"    movs    r0, #1\n"
"    movw    r5, #0x169\n"
"    movs    r2, #2\n"
"    mov     r1, sp\n"
"    str     r0, [sp]\n"
"    mov     r0, r5\n"
"    bl      _SetPropertyCase\n"
"    ldr     r0, [r4, #0x1c]\n"
"    movs    r3, #2\n"
"    mov     r2, sp\n"
"    mov     r1, r5\n"
"    bl      sub_fc325e22\n"
"loc_fc38dcbe:\n"
"    ldr.w   r0, [r7, #0x190]\n"
"    cbz     r0, loc_fc38dcc8\n"
"    bl      sub_fc1b73b6\n"
"loc_fc38dcc8:\n"
"    movs    r0, #0\n"
"    bl      sub_fc0b47de\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b75fe\n"
"    movs    r2, #4\n"
"    movs    r0, #0x92\n"
"    add     r1, sp, #4\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc38dcee\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1b1\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38dcee:\n"
"    ldr     r1, =0x000208b4\n"
"    ldr     r0, [sp, #4]\n"
"    str     r0, [r1]\n"
"    ldr.w   r0, [r7, #0xc8]\n"
"    cbnz    r0, loc_fc38dcfe\n"
"    bl      sub_fc0b4898\n"
"loc_fc38dcfe:\n"
"    bl      sub_fc1b7690\n"
"    movs    r1, #0\n"
"    mov     r0, r4\n"
"    bl      sub_fc38e088\n"    // set remote after that diferent than in gx7 but looks like
"    mov     r6, r0\n"
"    BL      wait_until_remote_button_is_released\n" // + remote hook
"bl log_remote_hook\n"
"    ldr     r0, [sp, #0xc]\n"
"    ubfx    r0, r0, #8, #8\n"
"    cmp     r0, #6\n"
"    bne     loc_fc38dd1a\n"
"    ldr     r5, =0xfc1b7381\n"
"    b       loc_fc38dd1c\n"
"loc_fc38dd1a:\n"
"    ldr     r5, =0xfc1b7397\n"
"loc_fc38dd1c:\n"
"    ldrh    r0, [r4, #0x18]\n"
"    cbz     r0, loc_fc38dd28\n"
"    cmp     r0, #1\n"
"    beq     loc_fc38dd3e\n"
"    cmp     r0, #4\n"
"    bne     loc_fc38ddb0\n"
"loc_fc38dd28:\n"
"    str     r6, [sp]\n"
"    mov     r3, r5\n"
"    ldr     r1, [r4, #0x60]\n"
"    mov     r0, r4\n"
"    ldr     r2, [sp, #4]\n"
"    bl      sub_fc1b6f28\n"
"    mov     r5, r0\n"
"    bl      sub_fc17f5ec\n"
"    b       loc_fc38ddbe\n"
"loc_fc38dd3e:\n"
"    ldr.w   r0, [r7, #0xc8]\n"
"    cbz     r0, loc_fc38dd50\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1cb\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38dd50:\n"
"    str     r6, [sp]\n"
"    mov     r3, r5\n"
"    ldr     r1, [r4, #0x60]\n"
"    mov     r0, r4\n"
"    ldr     r2, [sp, #4]\n"
"    bl      sub_fc1b6fa0\n"
"    movs    r2, #1\n"
"    mov     r5, r0\n"
"    movs    r1, #0\n"
"    movs    r0, #0x45\n"
"    bl      sub_fc26fbce\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc38ddbe\n"
"    ldr.w   r0, [r7, #0x104]\n"
"    cbz     r0, loc_fc38dd84\n"
"    ldr     r1, [r4, #8]\n"
"    ldr     r2, =0x001e16d0\n"
"    ldr     r0, [r4, #0x60]\n"
"    add.w   r1, r2, r1, lsl #2\n"
"    str     r0, [r1, #-0x4]\n"
"    b       loc_fc38ddaa\n"
"loc_fc38dd84:\n"
"    ldr     r0, =0xfc38dbf1\n"
"    movs    r1, #0\n"
"    bl      sub_fc15e020\n"
"    movs    r1, #1\n"
"    mov     r0, r4\n"
"    bl      sub_fc38e088\n"
"    mov     r6, r0\n"
"    ldr     r0, [sp, #4]\n"
"    bl      sub_fc1b7420\n"
"    ldr     r1, [r4, #0x60]\n"
"    mov     r3, r6\n"
"    ldr     r2, [sp, #4]\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b7012\n"
"    mov     r5, r0\n"
"loc_fc38ddaa:\n"
"    bl      sub_fc1b6ed0\n"
"    b       loc_fc38ddbe\n"
"loc_fc38ddb0:\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1f4\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"    movs    r5, #0x1d\n"
"loc_fc38ddbe:\n"
"    bl      sub_fc1b7694\n"
"    ldr.w   r8, =0xfc38dbf1\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc38de1a\n"
"    ldr.w   r0, [r7, #0x10c]\n"
"    cbnz    r0, loc_fc38dde6\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b836a\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc38dde6\n"
"    movs    r0, #0\n"
"    movw    r2, #0x211\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38dde6:\n"
"bl log_rh\n"   /// new stuff
"    BL      capt_seq_hook_raw_here\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b7680\n"
//"bl log_t1\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b7654\n"
//"bl log_t2\n"
"    cmp     r6, r8\n"
"    beq     loc_fc38de1a\n"
"    bl      sub_fc1b7cfe\n"
"    movs    r1, #4\n"
"    movw    sb, #0x21e\n"
"    ldr     r3, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    movw    r2, #0x3a98\n"
"    str.w   sb, [sp]\n"
"    bl      sub_fc2eb770\n"
"    cbz     r0, loc_fc38de1a\n"
"    movs    r0, #0\n"
"    mov     r2, sb\n"
"    ldr     r1, =0xfc38e000\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2ed804\n" // j_DebugAssert
"loc_fc38de1a:\n"
"    ldr.w   r0, [r7, #0x190]\n"
"    cbz     r0, loc_fc38de2a\n"
"    movs    r2, #1\n"
"    movs    r1, #0\n"
"    movs    r0, #0x46\n"
"    bl      sub_fc26fbce\n"
"loc_fc38de2a:\n"
"    movs    r1, #2\n"
"    mov     r2, r4\n"
"    mov     r0, r5\n"
"    bl      sub_fc0b11b8\n"
"    ldr     r0, [r7, #0x28]\n"
"    cmp     r0, #0\n"
"    mov     r0, r8\n"
"    beq     loc_fc38de50\n"
"    cmp     r6, r0\n"
"    beq     loc_fc38de44\n"
"    movs    r1, #1\n"
"    b       loc_fc38de46\n"
"loc_fc38de44:\n"
"    movs    r1, #0\n"
"loc_fc38de46:\n"
"    mov     r2, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b807e\n"
"    b       loc_fc38de62\n"
"loc_fc38de50:\n"
"    cmp     r6, r0\n"
"    beq     loc_fc38de58\n"
"    movs    r1, #1\n"
"    b       loc_fc38de5a\n"
"loc_fc38de58:\n"
"    movs    r1, #0\n"
"loc_fc38de5a:\n"
"    mov     r2, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1b8038\n"
"loc_fc38de62:\n"
"    add     sp, #0x10\n"
"    mov     r0, r5\n"
"    pop.w   {r4, r5, r6, r7, r8, sb, sl, pc}\n"
".ltorg\n"
    );
}  // SX720

// LIKe in gx7 not yet using this:
// not using DvlpSeq, multiple shots may be taken before task runs, out of sync with file counter
#if 0
void log_dvlp_seq(int m,int m2)
{
    _LogCameraEvent(0x60,"dvlp m:%d m2:0x%x arb:%d rb:0x%08x i:%04d",
                    m,
                    m2,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());

}
void log_dvlp_raw_hook(int m)
{
    _LogCameraEvent(0x60,"dvlp rh m:%d arb:%d rb:0x%08x i:%04d",
                    m,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}
void log_dvlp_seq_1(void)
{
    _LogCameraEvent(0x60,"dvlp seq loop");
}
void log_dvlp_seq_start(void)
{
    _LogCameraEvent(0x60,"dvlp seq start");
}
// -s=task_DvlpSeqTask -c=100 -f=chdk
// task_DvlpSeqTask 0xfc1e6837
void __attribute__((naked,noinline)) developseq_task() {
    asm volatile (
"    push.w  {r2, r3, r4, r5, r6, r7, r8, lr}\n"
"bl log_dvlp_seq_start\n"
"    ldr     r7, =0x0003fad4\n"
"    movs    r5, #0\n"
"    ldr     r6, =0x00014780\n"
"loc_fc1e6840:\n"
"bl log_dvlp_seq_1\n"
"    movs    r2, #0\n"
"    ldr     r1, [r6, #0x10]\n"
"    ldr     r0, [r6, #8]\n"
"    blx     sub_fc2ef87c\n" // j_PostMessageQueue
"    ldr     r0, [r6, #4]\n"
"    movs    r2, #0\n"
"    add     r1, sp, #4\n"
"    blx     sub_fc2ef8ec\n" // j_ReceiveMessageQueue
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1e685e\n"
"    movw    r2, #0x1c4\n"
"    b       loc_fc1e686e\n"
"loc_fc1e685e:\n"
"    ldr     r0, [r6, #8]\n"
"    mov     r1, sp\n"
"    blx     sub_fc2ef70c\n" // j_TryReceiveMessageQueue
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1e687e\n"
"    movw    r2, #0x1ca\n"
"loc_fc1e686e:\n"
"    movs    r0, #0\n"
"    ldr     r1, =0xfc1e6bd8\n" //  *"SsDvlpSeq.c"
"    blx     sub_fc2ef9e4\n" // j_DebugAssert
"    blx     sub_fc2ef90c\n"
"    pop.w   {r2, r3, r4, r5, r6, r7, r8, pc}\n"
"loc_fc1e687e:\n"
"    ldr.w   r0, [r7, #0x18c]\n"
"    cbz     r0, loc_fc1e688c\n"
"    ldr     r0, [sp, #4]\n"
"    ldr     r0, [r0]\n"
"    cmp     r0, #5\n"
"    bne     loc_fc1e6898\n"
"loc_fc1e688c:\n"
"    bl      sub_fc3d4f92\n"
"    bl      sub_fc1524bc\n"
"    bl      sub_fc1e8680\n"
"loc_fc1e6898:\n"
"ldr     r0, [sp, #4]\n"
"ldr     r0, [r0]\n"
"ldr     r1, [sp]\n"
"bl      log_dvlp_seq\n"
"    ldr     r0, [sp, #4]\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #6\n"
"    bhs     loc_fc1e691e\n"
"    tbb     [pc, r1]\n" // (jumptable r1 6 elements)
"branchtable_fc1e68a4:\n"
"    .byte((loc_fc1e68aa - branchtable_fc1e68a4) / 2)\n" // (case 0)
"    .byte((loc_fc1e68b2 - branchtable_fc1e68a4) / 2)\n" // (case 1)
"    .byte((loc_fc1e68b8 - branchtable_fc1e68a4) / 2)\n" // (case 2)
"    .byte((loc_fc1e68dc - branchtable_fc1e68a4) / 2)\n" // (case 3)
"    .byte((loc_fc1e690e - branchtable_fc1e68a4) / 2)\n" // (case 4)
"    .byte((loc_fc1e6914 - branchtable_fc1e68a4) / 2)\n" // (case 5)
".align 1\n"
"loc_fc1e68aa:\n" // case 0
"ldr     r0, [sp, #4]\n"
"ldr     r0, [r0]\n"
"bl      log_dvlp_raw_hook\n"
//"    BL      capt_seq_hook_raw_here\n" // test
"ldr     r0, [sp, #4]\n"
"ldr     r1, [r0]\n"
"    ldr     r0, [r0, #8]\n"
"    bl      sub_fc1e7a2a\n"
"    b       loc_fc1e691e\n"
"loc_fc1e68b2:\n"
"    bl      sub_fc3d5050\n"
"    b       loc_fc1e691e\n"
"loc_fc1e68b8:\n"
"    ldr     r2, [r0, #8]\n"
"    movs    r1, #1\n"
"    str.w   r1, [r2, #0x108]\n"
"    ldr     r0, [r0, #8]\n"
"    bl      sub_fc1e783a\n"
"    ldr     r0, [sp, #4]\n"
"    ldr     r0, [r0, #8]\n"
"    str.w   r5, [r0, #0x108]\n"
"    ldr     r0, [r6, #0xc]\n"
"    blx     sub_fc2ef96c\n"
"    ldr     r0, [sp, #4]\n"
"    movs    r1, #0xd\n"
"    ldr     r2, [r0, #8]\n"
"    b       loc_fc1e6918\n"
"loc_fc1e68dc:\n"
"    ldr.w   r1, [r7, #0xc0]\n"
"    cbz     r1, loc_fc1e68f8\n"
"    ldr     r0, [r0, #8]\n"
"    ldr.w   r1, [r0, #0xfc]\n"
"    cmp     r1, #1\n"
"    bne     loc_fc1e68f0\n"
"loc_fc1e68ec:\n"
"    movs    r1, #1\n"
"    b       loc_fc1e68f2\n"
"loc_fc1e68f0:\n"
"    movs    r1, #0\n"
"loc_fc1e68f2:\n"
"    bl      sub_fc1e75fa\n"
"    b       loc_fc1e691e\n"
"loc_fc1e68f8:\n"
"    ldr.w   r1, [r7, #0x1cc]\n"
"    cbz     r1, loc_fc1e690a\n"
"    ldrh.w  r1, [r7, #0x1ec]\n"
"    cmp     r1, #1\n"
"    beq     loc_fc1e690a\n"
"    ldr     r0, [r0, #8]\n"
"    b       loc_fc1e68f0\n"
"loc_fc1e690a:\n"
"    ldr     r0, [r0, #8]\n"
"    b       loc_fc1e68ec\n"
"loc_fc1e690e:\n"
"    bl      sub_fc1515f6\n"
"    b       loc_fc1e691e\n"
"loc_fc1e6914:\n"
"    movs    r2, #0\n"
"    movs    r1, #0x12\n"
"loc_fc1e6918:\n"
"    movs    r0, #0\n"
"    bl      sub_fc14e934\n"
"loc_fc1e691e:\n"
/*
"ldr     r0, [sp, #4]\n"
"ldr     r0, [r0]\n"
"bl      log_dvlp_raw_hook\n"
"    BL      capt_seq_hook_raw_here\n" // test
*/
"    ldr     r4, [sp, #4]\n"
"    ldr     r0, [r4, #4]\n"
"    cbnz    r0, loc_fc1e692e\n"
"    movs    r2, #0x86\n"
"    movs    r0, #0\n"
"    ldr     r1, =0xfc1e6bd8\n" //  *"SsDvlpSeq.c"
"    blx     sub_fc2ef9e4\n" // j_DebugAssert
"loc_fc1e692e:\n"
"    str     r5, [r4, #4]\n"
"    add     r1, sp, #4\n"
"    ldr     r0, [r6, #4]\n"
"    blx     sub_fc2ef70c\n" // j_TryReceiveMessageQueue
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1e687e\n"
"    b       loc_fc1e6840\n"
".ltorg\n"
    );
}
#endif
